<?php
###############################################################################
#
# StatsLab Database Load From Server
#
# Modify the 3 variables below to match the settings
#   on your StatsLab Admin page
#
# Run this script by typing 'php server_db_update.php'
#
###############################################################################

## Set the admin path to the full server path of your SQL upload folder
##  If this is not entered here, the setting in config.txt will be used
$adminpath="";

## Set the lgid to the league ID of the primary StatsLab league
##  If this is not changed, the admin page setting will be used.
$lgid=0;

## Set the maximum file size of SQL files you wish to load
$maxSize="";

## Set the verbose variable to 1 for more detail on the SQL load progress
$verbose=1;

###############################################################################
#############------------ DO NOT EDIT BELOW THIS LINE ------------#############
###############################################################################

if (($timeout<30) || ($timeout=="")) {$timeout=120;}

##### Get Adminpath if null #####
if ($adminpath=="")
 {
   if (file_exists("./config.txt"))
    {
      $fpath="./config.txt";
      $f = fopen ($fpath, "r");
      $line = explode("|",fread($f,filesize($fpath)));
      $adminpath = $line[1];
      fclose($f);
    }
    else {echo "Unable to find config.txt\n";}
 }

##### Quit out if information not specified #####
if ($adminpath=="") {echo "Unable to determine SQL upload directory\n";exit;}

include($adminpath."/dbopen.php");

##### Get league ID if not set #####
$cwd=getcwd();
$e=explode("/",$cwd);
$maxE=count($e)-1;
$install=$e[$maxE];
$query="SHOW TABLES LIKE 'ootp_sql_admin';";
$result=mysql_query($query,$db);
if (mysql_num_rows($result)) 
 {
   $query="SELECT * FROM ootp_sql_admin WHERE install='$install' AND setting='priLgID';";
   $result=mysql_query($query,$db);
   if (mysql_num_rows($result)) 
    {
      while ($row=mysql_fetch_array($result))
       {
         $field=$row['setting'];
         $val=$row['value'];
	 $val=stripslashes($val);
         switch ($field)
          {
	    case 'priLgID'     : $lgid=$val;      break;
	  }
       }
    }
    else {echo "ERROR: Invalid query: $query\n";}
 }
 else {echo "ERROR: Invalid query: $query\n";}

##### Quit out if information not specified #####
if ($lgid==0) {echo "Please edit server_db_update.php file with the league ID\n";exit;}
if ($verbose==0) {echo "Loading SQL Files in basic mode\n";}
 else {echo "Loading SQL Files in verbose mode\n -> Each . is 1000 queries processed\n";}

##### Get Old League Date #####
$query="SHOW TABLES LIKE 'leagues';";
$result=mysql_query($query,$db);
if (mysql_num_rows($result))
 {
   $query="SELECT leagues.current_date FROM leagues WHERE league_id=".$lgid." GROUP BY leagues.current_date;";
   $result=mysql_query($query,$db);
   if (mysql_num_rows($result))
   {
     $row=mysql_fetch_array($result);
     $oldLgDate=$row[0];
     if ($verbose==1) {echo "Old league date: $oldLgDate\n";}
   }
 }

##### Load SQL Files #####
$loadCnt=0;
if ($dir = opendir($adminpath))
 {
   $now=time();    
   if ($verbose==1) {echo "Reading $adminpath\n";}
   while (false !== ($file = readdir($dir)))
    {

      $ex = explode(".",$file);
      $last = count($ex)-1;
      $fileTime=filemtime($adminpath."/".$file);
      $fileSize=filesize($adminpath."/".$file);
      
      if (($maxSize!="")&&($maxSize>0)&&($fileSize>$maxSize)) {continue;}

      if (($ex[$last]=="sql") && ($file!=".") && ($file!=".."))
       {
         $fileList[$loadCnt]=$file;
	 $loadCnt++;
       }
    }
   if ($verbose==1) {echo "loadCnt: $loadCnt\n";}
	
   if ($loadCnt>0)
    {
      asort($fileList);
      foreach ($fileList as $key => $file)
       {
         $ex = explode(".",$file);
	 set_time_limit($timeout);
   	 $fnow=time();

	 $tableName=$ex[0];
         if ($verbose==1) {echo "Beginning $tableName load > ";}
	 $query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES ('File Load', '4dm1n', 'Load Status', 'Loading $tableName') ON DUPLICATE KEY UPDATE value='Loading $tableName';";
	 mysql_query($query,$db);

	 $query="CREATE TABLE IF NOT EXISTS `$tableName';";
	 mysql_query($query,$db);

	 ## Import data
	 $file=$adminpath."/".$file;
	 $fr = fopen($file,"r");
   	 $errCnt=0;
	 if (isset($errors))
  	  { 
            unset($errors);
	    unset($queries);
	  }
	 $cnt=0;
	 while (!feof($fr))
  	  {
            $query=fgets($fr);
	    if ($query=="") {continue;}
	    $query=str_replace(", , );",",1,1);",$query);
	    $query=preg_replace("/([\xC2\xC3])([\x80-\xBF])/e","chr(ord('\\1')<<6&0xC0|ord('\\2')&0x3F)",$query);
   	    $query=str_replace(", ,",",'',",$query);
	    $query=str_replace("#IND",0,$query);
   	    if (($tableName=='players_career_batting_stats')||($tableName=='players_career_pitching_stats'))
	     {
	       $query=str_replace("insert into","insert ignore into",$query);
	     }
	    $cnt++;
            if (($verbose==1)&&(($cnt%1000)==0)) {echo ".";}
   	    $result=mysql_query($query,$db);
	    $err=mysql_error($db);
   	    if (($err!="") && ($query!=""))
	     {
	       $errors[$errCnt]=$err;
	       $queries[$errCnt]=$query;
   	       $errCnt++;
   	     }
	    if ((substr_count($query,"CREATE ")>0)&&(($tableName=='players_career_batting_stats')||($tableName=='players_career_pitching_stats')))
  	     {
	       $query="ALTER TABLE $tableName ADD PRIMARY KEY (player_id,year,team_id,league_id,split_id);";
	       $result=mysql_query($query,$db);
   	     }
	  }
   	 fclose($fr);

         ## Report Errors
         $fend=time();
         if ($errCnt==0)
          {
	    $ltime=$fend-$fnow;
	    $query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES (";
   	    $query.="'File Load','4dm1n','$tableName'";
	    $query.=",'$fend|$ltime'";
	    $query.=") ON DUPLICATE KEY UPDATE value='$fend|$ltime';";
   	    mysql_query($query,$db);
          }
          else
          {
            for ($i=0;$i<$errCnt;$i++)
	     {
  	       echo "ERROR in $tableName:\n  ".$queries[$i]." -> ".$errors[$i]."\n";
	     }
	  }
         if ($verbose==1) {echo " processing complete\n";}
       }
      $end=time();
    }
 }
 else
 {
   echo "ERROR: Unable to read directory ".$adminpath;
 }

 if ($loadCnt==0)
  {
    $tmp="LOAD STATUS: No files loaded!\n";
    $tmp.="You may have one of the following problems:\n";
    $tmp.=" 1. The path to the SQL files is incorrect.\n";
    $tmp.=" 2. The SQL files are not uploaded to the server.\n";
    echo $tmp;
  }
  else {echo "LOAD STATUS: $loadCnt files processed\n";}

##### Update Human Managers #####
$query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES ('File Load', '4dm1n', 'Load Status', 'Processing Users') ON DUPLICATE KEY UPDATE value='Processing Users';";
mysql_query($query,$db);
## Check if user table exists
$query="SHOW TABLES LIKE 'ootp_sql_users';";
$result=mysql_query($query,$db);
if (!mysql_num_rows($result))
 {
   ##### Initialize Table #####
   $query="CREATE TABLE IF NOT EXISTS ootp_sql_users (human_manager_id INT, username VARCHAR(80), password VARCHAR(80), email VARCHAR(80), forum_name VARCHAR(80), pm_link VARCHAR(180), ext_url VARCHAR(255), aim VARCHAR(80), yim VARCHAR(80), msn VARCHAR(80), icq VARCHAR(80), facebook VARCHAR(180), twitter VARCHAR(180), hide_info SMALLINT DEFAULT 1, auto SMALLINT DEFAULT 0, auto_list SMALLINT DEFAULT 0, auto_round_x INT DEFAULT NULL, PRIMARY KEY (human_manager_id));";
   $result=mysql_query($query,$db);
 }
 
## Get OOTP Managers
$query="SELECT human_manager_id,first_name,last_name FROM human_managers;";
$result=mysql_query($query,$db);
$updText="";
if (mysql_num_rows($result))
 {
   while ($row=mysql_fetch_array($result))
    {
      $hmid=$row['human_manager_id'];
      $name=$row['first_name']." ".$row['last_name'];
      $updText.="INSERT INTO ootp_sql_users (human_manager_id,username,password) VALUES ('".$hmid."','".$name."',PASSWORD('baseball')) ON DUPLICATE KEY UPDATE username='$name';\n";
    }
 }

## Load Managers
if ($updText!="")
 {
   $updText=trim($updText,",");
   $updText=trim($updText);
   $e=explode("\n",$updText);
   foreach ($e as $key => $query)
    {
      mysql_query($query,$db);
      $err=mysql_error();
      if ($err!="") {echo $err."\n";}
    }
 }

##### Clear Auto Draft List #####
$query="UPDATE ootp_sql_admin SET value=0 WHERE module='Draft' AND setting='autoList';";
mysql_query($query,$db);

##### Get New League Date #####
$query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES ('File Load', '4dm1n', 'Load Status', 'Checking Date') ON DUPLICATE KEY UPDATE value='Checking Date';";
mysql_query($query,$db);
$query="SELECT leagues.current_date,'$oldLgDate' as last_date,DATEDIFF(leagues.current_date,'$oldLgDate')+1 as days FROM leagues WHERE league_id=".$lgid.";";
$result=mysql_query($query,$db);
$row=mysql_fetch_array($result);
$newLgDate=$row[0];
$simLength=$row['days'];

if ($simLength>1)    ## Update of existing tables ##
 {
   $_SESSION['lgdate']=$newLgDate;

   ## Save off Settings
   $query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES ('Last Sim','4dm1n','LastDate','$oldLgDate') ON DUPLICATE KEY UPDATE value='$oldLgDate';";
   mysql_query($query,$db);
   $query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES ('Last Sim','4dm1n','calcLength','$simLength') ON DUPLICATE KEY UPDATE value='$simLength';";
   mysql_query($query,$db);

   $query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES ('File Load', '4dm1n', 'Load Status', 'Done') ON DUPLICATE KEY UPDATE value='Done';";
   mysql_query($query,$db);
 }
 else
 {
   $query="INSERT INTO ootp_sql_admin (module, install, setting, value) VALUES ('File Load', '4dm1n', 'Load Status', 'Done') ON DUPLICATE KEY UPDATE value='Done';";
   mysql_query($query,$db);
 }

?>
